// Generated by CoffeeScript 1.3.3
(function() {
  var PriorityQueue, Trampoline;

  PriorityQueue = require("./priority_queue").PriorityQueue;

  Trampoline = (function() {

    function Trampoline(state) {
      this.state = state;
      this.work = new PriorityQueue();
      this.cache = {};
    }

    Trampoline.prototype.push = function(priority, description, job) {
      return this.work.put({
        description: description,
        job: job
      }, priority);
    };

    Trampoline.prototype.size = function() {
      return this.work.length();
    };

    Trampoline.prototype.next = function() {
      var item,
        _this = this;
      this.state.debug(function() {
        var item;
        return [
          "fetch next job:", (function() {
            var _i, _len, _ref, _results;
            _ref = this.work.inspect();
            _results = [];
            for (_i = 0, _len = _ref.length; _i < _len; _i++) {
              item = _ref[_i];
              _results.push("[" + item.priority + "] " + (item.item.description()));
            }
            return _results;
          }).call(_this)
        ];
      });
      item = this.work.get();
      if (item != null) {
        return item.job();
      }
    };

    Trampoline.prototype.ready = function() {
      return !this.work.isEmpty();
    };

    Trampoline.prototype.getCache = function(parser, state) {
      var entry, x;
      x = this.cache[parser.id];
      if (!(x != null)) {
        this.cache[parser.id] = x = {};
      }
      entry = x[state.pos];
      if (!(entry != null)) {
        x[state.pos] = entry = {
          continuations: [],
          results: []
        };
      }
      return entry;
    };

    return Trampoline;

  })();

  exports.Trampoline = Trampoline;

}).call(this);
